//+------------------------------------------------------------------+
//|                                               Advanced forecater |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    FastEma      = 13;
extern int    SlowEma      = 34;
extern int    SignalMA     = 8;
extern int    SignalMAMode = MODE_EMA;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double temp1[];
double temp2[];
double sum[];
double sumua[],sumu[];
double sumub[],sumd[];
double sumda[];
double sumdb[];
double dotu[];
double dotd[];
double state[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init() 
{
   IndicatorBuffers(12);   
   SetIndexBuffer(0,sumu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sumd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,sum);
   SetIndexBuffer(3,sumua);
   SetIndexBuffer(4,sumub);
   SetIndexBuffer(5,sumda);
   SetIndexBuffer(6,sumdb);
   SetIndexBuffer(7,dotu);  
   SetIndexBuffer(8,dotd);  
   SetIndexBuffer(9,temp1);
   SetIndexBuffer(10,temp2);
   SetIndexBuffer(11,state);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
   IndicatorShortName(timeFrameToString(timeFrame)+" Advanced_forecater");
   return (0);
}

//
//
//
//
//

int start() 
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int i,limit = MathMin(Bars-countedBars,Bars-1);
            if (returnBars) { sumu[0] = limit+1; return(0); }
            double Multiply_Factor_1 = 2.0 / (FastEma + 1.0);
            double Multiply_Factor_2 = 2.0 / (SlowEma + 1.0);
            double Multiply_Factor_3 = Multiply_Factor_1 - Multiply_Factor_2;
                  if (MathAbs(Multiply_Factor_3) == 0.0) return(0);
                  if (timeFrame!=Period())
                  {
                     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
                     if (state[limit]== 1) CleanPoint(limit,sumua,sumub);
                     if (state[limit]==-1) CleanPoint(limit,sumda,sumdb);
                        for(i=limit; i>=0; i--)
                        {
                           int y = iBarShift(NULL,timeFrame,Time[i]);
                           sumu[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEma,SlowEma,SignalMA,SignalMAMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
                           sumd[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEma,SlowEma,SignalMA,SignalMAMode,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
                        }                              
                        return(0);
                  }

   //
   //
   //
   //
   //
 
   for(i=limit; i>=0; i--) temp1[i] = iMA(NULL,0,FastEma,0,MODE_EMA, PRICE_CLOSE,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) temp2[i] = iMAOnArray(temp1,0,SignalMA,0,SignalMAMode,i);
   for(i=limit; i>=0; i--)
   {
      sumua[i] = EMPTY_VALUE;
      sumub[i] = EMPTY_VALUE;
      sumda[i] = EMPTY_VALUE;
      sumdb[i] = EMPTY_VALUE;
      dotd[i]  = EMPTY_VALUE;
      dotu[i]  = EMPTY_VALUE;
      sum[i] = (Multiply_Factor_1 * iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)+                  iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) - 
                                    iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)-Multiply_Factor_2*iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i) + temp2[i]) / Multiply_Factor_3;
      state[i] = 0;
      sumu[i]  = EMPTY_VALUE;
      sumd[i]  = EMPTY_VALUE;
      if (sum[i]>High[i]) state[i] =  1;
      if (sum[i]<Low[i])  state[i] = -1;
      if (state[i] == -1) sumu[i] = 1;
      if (state[i] ==  1) sumd[i] = 1;
   }
   manageAlerts();
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (state[whichBar]!=state[whichBar+1])
      {
         if (state[whichBar] ==  1) doAlert(whichBar,"down");
         if (state[whichBar] == -1) doAlert(whichBar,"up");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," "+timeFrameToString(Period())+" at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Advanced forecaster trend changeed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Advanced forecaster "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}